#ifndef _HG_DATUM_H_
#define _HG_DATUM_H_

#include <string>
#include <iostream>

namespace HG //Beginn des Namensraumes
{

//==============================================================
// Klasse Datum
//==============================================================
class Datum
{
  //------------------------------------------------------------
  // Constructoren
  //------------------------------------------------------------
  public:
     Datum (void);            // Standardconstructor
     Datum (Datum &pDatum);   // Copy-Constructor
     Datum (Datum *ptrDatum); // "Copy"-Constructor (nicht automatisch)
     Datum (int pTag, int pMonat, int pJahr);

  //------------------------------------------------------------
  // Methoden 
  //------------------------------------------------------------
  public:
    void        set                (int pTag, int pMonat, int pJahr);
    long        getLong            (void);
    long        getLongSortierbar  (void);
    void        setHeute           (void);
    bool        isSchaltjahr       (int pJahr);
    int         maxTageImMonat     (int pMonat, int pJahr);
    Datum       addJahre           (int pToAdd);
    Datum       subJahre           (int pToSub);
    Datum       addMonate          (int pToAdd);
    Datum       subMonate          (int pToSub);
    Datum       addTage            (int pToAdd);
    Datum       subTage            (int pToSub);

  //------------------------------------------------------------
  // Methoden: berladene Operatoren
  //------------------------------------------------------------
   Datum operator++ (void);  // Operator: Princrement
   Datum operator++ (int);   // Operator: Postincrement
   Datum operator-- (void);  // Operator: Prdecrement
   Datum operator-- (int);   // Operator: Postdecrement
   Datum operator+  (int pToAdd);
   Datum operator-  (int pToSubtract);
   Datum operator=  (Datum &pToCopy);
   bool  operator== (Datum &pToCompare);
   bool  operator!= (Datum &pToCompare);
   bool  operator>  (Datum &pToCompare);
   bool  operator>= (Datum &pToCompare);
   bool  operator<  (Datum &pToCompare);
   bool  operator<= (Datum &pToCompare);

  //------------------------------------------------------------
  // Methoden: Getter und Setter 
  //------------------------------------------------------------
  public:
    int  getTag   (void);
    void setTag   (int pTag);
    int  getMonat (void);
    void setMonat (int pMonat);
    int  getJahr  (void);
    void setJahr  (int pJahr);

  //------------------------------------------------------------
  // Methoden, intern
  //------------------------------------------------------------
  private:
    void correct (void);

  //------------------------------------------------------------
  // Member
  //------------------------------------------------------------
  private:
    int nTag;
    int nMonat;
    int nJahr;
};

} // Ende des Namensraumes

// int operator+ (int pToAdd, Datum &pTarget); // Version 1
HG::Datum operator+ (int pToAdd, HG::Datum &pTarget); // Version 2
// int operator- (int pToSubtract, Datum &pTarget); // Version 1
HG::Datum operator- (int pToSubtract, HG::Datum &pTarget); // Version 2
std::ostream& operator<< (std::ostream &pStream, HG::Datum &pToShow);
#endif